APT-GET(8)

de Noviembre de 2008

NAME
apt-get - Herramienta de gestión de paquetes APT -- interfaz para la línea de órdenes

SYNOPSIS

apt-get [-sqdyfmubV] [-o= cadena-de-configuración ] [-c= fichero-de-configuración ] [-t= nombre-de-la-versión-objetivo] {update | upgrade | dselect-upgrade | dist-upgrade | install paquete [ { =versión-del-paquete | /nombre-de-la-versión-objetivo } ] ... | remove paquete... | purge paquete... | source paquete [ { =versión-del-paquete | /nombre-de-la-versión-objetivo } ] ... | build-dep paquete... | check | clean | autoclean | autoremove | {-v | --version} | {-h | --help}}

DESCRIPCIóN

apt-get es la herramienta para la gestión de paquetes desde la línea de órdenes, y se puede considerar el sistema de «bajo nivel» de otras herramientas de usuario que usan la biblioteca de APT. Existen varias interfaces de «alto nivel», tales como dselect(1), aptitude(8), synaptic(8) y wajig(1).

A menos que se use la opción -h o --help, una de las siguientes órdenes debe estar presente.

update
    update se usa para sincronizar el índice de paquetes desde sus fuentes. Los índices de paquetes disponibles se obtienen de los lugares especificados en /etc/apt/sources.list. Por ejemplo, cuando se usa un archivo de Debian, esta orden descarga y analiza los ficheros Packages.gz, de tal forma que la información acerca de los nuevos paquetes pasa a estar disponible. Siempre se debe realizar un update antes de un upgrade o un dist-upgrade. Tenga en cuenta que el indicador de progreso será incorrecto, ya que se desconoce de antemano el tamaño de los archivos de paquete.

upgrade
    upgrade se usa para instalar la versión más nueva de todos los paquetes instalados en el sistema provenientes de alguna de las fuentes listadas en /etc/apt/sources.list. Los paquetes instalados con una nueva versión disponible se descargan y actualizan, y bajo ninguna circunstancia se desinstalarán paquetes, o se instalarán paquetes nuevos. Las nuevas versiones de programas instalados que no se puedan actualizar sin cambiar el estado de instalación de otros paquetes no se instalarán, manteniéndose la versión actual. Debe realizar un update antes para que apt-get sepa que hay nuevas versiones disponibles.

dselect-upgrade
    dselect-upgrade se usa junto al tradicional administrador de paquetes de Debian, dselect(1). dselect-upgrade registra los cambios que haya hecho dselect(1) al campo Status (estado) de los paquetes disponibles y realiza las acciones necesarias para que los cambios se lleven a cabo (por ejemplo, borrar paquetes antiguos e instalar las nuevas versiones).

dist-upgrade
    dist-upgrade, además de realizar las acciones de upgrade, trata inteligentemente los cambios de dependencias debidos a las nuevas versiones de paquetes. apt-get tiene un sistema «inteligente» de resolución de conflictos, y si es necesario tratará de actualizar los paquetes más importantes a costa de los menos importantes. El fichero /etc/apt/sources.list contiene la lista de sitios desde los que descargar los ficheros de paquetes. También puede consultar apt_preferences(5) si quiere invalidar este comportamiento para paquetes individuales.

install
    install instala o actualiza los paquetes que siguen a la palabra «install». Cada paquete es un nombre de paquete, y no el nombre completo del fichero del paquete (por ejemplo, en un sistema Debian GNU/Linux, el argumento sería libc6, no libc6_1.9.6-2.deb). Se obtendrán e instalarán todos los paquetes necesarios por los paquetes especificados para la instalación. El fichero /etc/apt/sources.list se usa para ubicar los paquetes. Si antepone un guión al nombre del paquete (sin ningún espacio) el paquete se desinstalará en vez de instalar. De forma similar, el signo de suma se puede usar para especificar que un paquete se debe instalar. Estas últimas características se pueden usar para invalidar las decisiones tomadas por el sistema de resolución de conflictos de apt-get.

    Puede seleccionar una versión especifica de un paquete poniendo a continuación del nombre del paquete un símbolo igual («=») seguido de la versión deseada. Esto provocará que se localice y seleccione esa versión para su instalación. Alternativamente se puede seleccionar una distribución específica poniendo a continuación del nombre del paquete una barra («/») seguida de la versión de la distribución o su nombre en el archivo de Debian (stable, testing, unstable).

    Cualquiera de estos dos métodos de selección puede instalar una versión anterior de los paquetes y se debe usar con cuidado.

    Esto también es el objetivo a usar si quiere actualizar uno o más paquetes instalados sin actualizar todos los paquetes del sistema. A diferencia del objetivo de «upgrade», que instala la versión más nueva de todos los paquetes instalados, «install» instalará la versión más nueva sólo de los paquetes especificados. Simplemente proporcione el nombre de los paquetes que quiere actualizar, y si una versión más nueva está disponible ésta (y sus dependencias, como se describió anteriormente) se descargarán e instalarán.

    Por último, apt_preferences(5) permite modificar las normas de selección para paquetes individuales.

    Si ningún paquete coincide con la expresión proporcionada y la expresión contiene un «.», «?» o un «*», entonces se asume que es una expresión regular de acuerdo con el estándar POSIX, y se aplica a todos los nombres de paquetes de la base de datos. Cualquier coincidencia se instala (o desinstala). Tenga en cuenta que la comparación se hace en subcadenas, de manera que «lo.*» es válido para «how-lo» y para «lowest». Si este no es el comportamiento deseado, debe anclar la expresión regular con un «^» o un «$», o bien crear una expresión regular más específica.

remove
    remove se comporta del mismo modo que install con la diferencia de que elimina los paquetes en vez de instalarlos. Tenga en cuenta que al eliminar un paquete sus ficheros de configuración se quedan en el sistema. Si un signo de suma precede al nombre del paquete (sin ningún espacio en blanco entre los dos), el paquete en cuestión será instalado en vez de eliminado.

purge
    purge es idéntico a remove, con la diferencia de que los paquetes se eliminarán y purgarán (se eliminará también cualquier fichero de configuración).

source
    source hace que apt-get descargue los paquetes fuente. APT examinará los paquetes disponibles para decidir qué paquete fuente descargará. Entonces descargará la versión más reciente del paquete fuente en el directorio actual respetando la versión predeterminada, que se define en la opción APT::Default-Release, la opción -t o según el paquete con la sintaxis pkg/release, si es posible.

    Los paquetes fuente se registran de forma separada a los paquetes binarios mediante líneas del tipo deb-src en el fichero sources.list(5). Esto significa que tendrá que añadir una línea como esa para cada repositorio del que quiera conseguir las fuentes. Si no hace esto obtendrá una versión de fuentes distinta (más nueva, vieja o ninguna) de la que tiene instalada o de la que podría instalar.

    Si se especifica la opción --compile el paquete se compilará en un binario «.deb» usando dpkg-buildpackage, si se especifica --download-only el paquete fuente no se desempaquetará.

    Puede obtener una versión especifica de un paquete fuente insertando un signo igual («=») seguido de la versión a descargar después del nombre del paquete, de forma similar al método que se usa con los paquetes binarios. Esto permite seleccionar exactamente el nombre y versión del paquete fuente, activando implícitamente la opción APT::Get::Only-Source.

    Tenga en cuenta que los paquetes fuentes no se tratan como los binarios, sólo existen en el directorio actual y es parecido a descargar los paquetes tar comprimidos con las fuentes.

build-dep
    build-dep hace que apt-get instale/desinstale paquetes en un intento de satisfacer las dependencias de compilación de un paquete fuente.

check
    check es una herramienta de diagnóstico, actualiza la caché de paquetes y revisa la existencia de dependencias rotas.

clean
    clean borra totalmente el repositorio local que contiene los ficheros de los paquetes descargados. Borra todo excepto el fichero de bloqueo de los directorios /var/cache/apt/archives/ y /var/cache/apt/archives/partial/. Cuando APT se usa como un método de dselect(1), clean se ejecuta automáticamente. Si no usa dselect es probable que desee ejecutar apt-get clean de vez en cuando para liberar algo de espacio en disco.

autoclean
    Al igual que clean, autoclean borra el repositorio local de paquetes descargados. La diferencia reside en que sólo borrará aquellos paquetes que ya no se pueden descargar, o que son claramente inservibles. Esto permite mantener el almacén durante largos periodos de tiempo sin que aumente su tamaño descontroladamente. Si la opción de configuración APT::Clean-Installed está desactivada impedirá que se borren los paquetes instalados.

autoremove
    autoremove se usa para desinstalar paquetes que se instalaron automáticamente para satisfacer las dependencias de algún paquete, pero que ya no son necesarios.

OPCIONES

Todas las opciones de la línea de órdenes se pueden definir mediante el fichero de configuración, las descripciones indican la opción de la configuración a definir. Para opciones de tipo «boolean» puede invalidar el fichero de configuración utilizando algo como -f-,--no-f, -f=no u otras muchas variaciones.

--no-install-recommends
    No considera los paquetes recomendados como dependencia al instalar. Opción de configuración: APT::Install-Recommends.

-d, --download-only
    Sólo descarga los ficheros de los paquetes, no los desempaqueta ni los instala. Opción de configuración: APT::Get::Download-Only.

-f, --fix-broken
    Intenta arreglar un sistema con dependencias actualmente rotas. Si se usa esta opción junto a «install»/«remove» se puede omitir cualquier paquete para permitir a APT deducir una posible solución. Si se especifican problemas, deben corregir totalmente el problema. La opción, a veces, se necesita cuando se ejecuta APT por primera vez, APT no permite que existan dependencias de paquetes rotas en un sistema. Es posible que la estructura de dependencias de un sistema esté tan deteriorada que requiera una intervención manual (generalmente puede ejecutar dselect(1) o dpkg --remove para desinstalar alguno de los paquetes que crean el conflicto). El uso de esta opción junto con -m puede producir un error en algunas situaciones. Opción de configuración: APT::Get::Fix-Broken.

-m, --ignore-missing, --fix-missing
    No tiene en cuenta los paquetes que no se hayan podido descargar o que después de la descarga se encuentren dañados (ficheros de paquete corruptos), estos paquetes se retienen y se continúa con el resto. Usar esta opción junto con -f puede producir un error en algunas situaciones. Si un paquete se selecciona para su instalación (particularmente si se hace mediante la línea de órdenes) y no se puede descargar, se le retendrá silenciosamente. Opción de configuración: APT::Get::Fix-Missing.

--no-download
    Deshabilita la descarga de paquetes. Usada junto con --ignore-missing ofrece la mejor manera de forzar a APT a usar sólo los ficheros «.deb» descargados con anterioridad. Opción de configuración: APT::Get::Download.

-q, --quiet
    Produce una salida adecuada para su registro, omitiendo los indicadores de progreso. Si se especifican más «q» (hasta un máximo de 2) se conseguirá una salida más silenciosa. También es posible usar -q=# para seleccionar el nivel de silencio, omitiendo el fichero de configuración. Tenga en cuenta que un nivel silencioso de 2 implica -y, por lo tanto nunca se deberá usar «-qq» sin añadir un modificador para que no realice ninguna acción como «-d», «--print-uris» o «-s» para evitar que APT realice algo que usted no espera. Opción de configuración: quiet.

-s, --simulate, --just-print, --dry-run, --recon, --no-act
    No realiza ninguna acción, simula lo que hubiese ocurrido pero sin hacer cambios reales en el sistema. Opción de configuración: APT::Get::Simulate.

    Si la simulación se ejecuta como usuario desactivará el bloqueo automático (Debug::NoLocking). Si la opción APT::Get::Show-User-Simulation-Note está activada (activa de forma predeterminada) se mostrará un mensaje indicando que sólo es una simulación. Ni se realizará «NoLocking» ni se mostrará el mensaje si se ejecuta como administrador («root»), ya que debería saber lo qué está haciendo sin más avisos de apt-get).

    La simulación muestra en la pantalla una serie de líneas, cada una de las cuales representa una operación de dpkg, configurar (Conf), desinstalar (Remv), o desempaquetar (Inst). Un par de corchetes indican paquetes con dependencias rotas, si no hay nada entre ellos significa que no hay ningún problema (poco probable).

-y, --yes, --assume-yes
    Supone una respuesta afirmativa a todas las preguntas, de esta forma apt-get se ejecuta sin necesidad de intervención posterior para tomar decisiones. apt-get terminará sin hacer nada de producirse una situación no deseada, como cambiar un paquete retenido, instalar un paquete sin autenticar o desinstalar un paquete esencial. Opción de configuración: APT::Get::Assume-Yes.

-u, --show-upgraded
    Muestra los paquetes que se van a actualizar. Opción de configuración: APT::Get::Show-Upgraded.

-V, --verbose-versions
    Muestra las versiones completas para los paquetes actualizados e instalados. Opción de configuración: APT::Get::Show-Versions.

-b, --compile, --build
    Descarga los paquetes fuente y luego los compila. Opción de configuración: APT::Get::Compile.

--install-recommends
    También instala los paquetes recomendados.

--no-install-recommends
    No instala los paquetes recomendados.

--ignore-hold
    Ignora los paquetes retenidos. Esto hace que apt-get ignore toda retención impuesta a un paquete. Esto puede ser útil junto a dist-upgrade para invalidar un gran número de paquetes retenidos de manera no deseada. Opción de configuración: APT::Ignore-Hold.

--no-upgrade
    No actualiza los paquetes. Cuando se usa junto a install, no-upgrade evita que se actualicen los paquetes listados en la línea de órdenes si ya están instalados. Opción de configuración: APT::Get::Upgrade.

--only-upgrade
    No instala paquetes nuevos. Cuando se usa junto a install, only-upgrade evita que se actualicen los paquetes listados en la línea de órdenes si no están ya instalados. Opción de configuración: APT::Get::Only-Upgrade.

--force-yes
    Supone una respuesta afirmativa a todas las preguntas. Ésta es una opción peligrosa que hará que apt continúe sin preguntar incluso si se va a realizar algo potencialmente peligroso. No se debe usar excepto en situaciones muy especiales. ¡Usar force-yes puede destruir su sistema! Opción de configuración: APT::Get::force-yes.

--print-uris
    Muestra las URI de los ficheros a instalar en vez de descargarlos. Cada URI contiene la dirección de dónde se obtendrá el paquete, el fichero de destino, su tamaño y el resumen MD5 esperado. Tenga en cuenta que el nombre de fichero no siempre coincide con el nombre del fichero en el sitio remoto. Esto también funciona con las órdenes source y update. Cuando se usa con la orden update no se incluyen ni el resumen MD5 ni el tamaño, y es tarea del usuario descomprimir cualquier fichero comprimido. Opción de configuración: APT::Get::Print-URIs.

--purge
    Usa «purge» (purgar) en lugar de «remove» para todo aquello que se desinstale. Un asterisco («*») aparecerá a continuación de los paquetes que se vayan a purgar. remove --purge es equivalente a la orden purge. Opción de configuración: APT::Get::Purge.

--reinstall
    Reinstala los paquetes ya instalados, incluso si son la última versión disponible del paquete. Opción de configuración: APT::Get::ReInstall.

--list-cleanup
    Esta opción está activada de forma predeterminada, si quiere desactivarla use --no-list-cleanup. Cuando está activada apt-get administrará automáticamente los contenidos de /var/lib/apt/lists para asegurarse de que se borran los ficheros obsoletos. La única razón para desactivarla es si realiza frecuentemente cambios en la lista de fuentes. Opción de configuración: APT::Get::List-Cleanup.

-t, --target-release, --default-release
    Esta opción controla la entrada predeterminada del motor de directrices, creando un anclaje («pin») con una prioridad 990 usando la cadena de caracteres de la distribución especificada. Esto invalida la configuración general de /etc/apt/preferences. Aquellos paquetes con un anclaje específico no se verán afectados por el valor de esta opción. Resumiendo, esta opción le da control sobre la distribución de la que se obtienen los paquetes. Algunos ejemplos comunes pueden ser -t '2.1*' o -t unstable o -t sid. Opción de configuración: APT::Default-Release. Vea también la página del manual de apt_preferences(5).

--trivial-only
    Sólo realiza acciones consideradas «triviales». Esta opción está relacionada con --assume-yes de modo que dónde --assume-yes responde afirmativamente a cualquier pregunta, --trivial-only responderá negativamente. Opción de configuración: APT::Get::Trivial-Only.

--no-remove
    Si se va a desinstalar algún paquete, apt-get terminará inmediatamente sin preguntar. Opción de configuración: APT::Get::Remove

--auto-remove
    Si la orden es install o remove, esta opción se ejecutará como autoremove, eliminando los paquetes que son dependencia de otro, pero que estén en desuso. Opción de configuración: APT::Get::AutomaticRemove.

--only-source
    Sólo tiene sentido para las órdenes source y build-dep. Indica que los nombres de paquetes fuente proporcionados no se deben tratar a través de la tabla de binarios. Esto significa que si se especifica esta opción, estas órdenes sólo aceptarán como argumento nombres de paquetes fuente, en vez de aceptar nombres de paquetes binarios, para luego buscar el nombre del paquete fuente correspondiente. Opción de configuración: APT::Get::Only-Source

--diff-only, --dsc-only, --tar-only
    Descarga sólo el fichero diff, dsc o tar del archivo de fuentes. Opciones de configuración: APT::Get::Diff-Only, APT::Get::Dsc-Only y APT::Get::Tar-Only.

--arch-only
    Procesa sólo las dependencias de construcción dependientes de la arquitectura. Opción de configuración: APT::Get::Arch-Only

--allow-unauthenticated
    Ignora si los paquetes no se pueden autenticar, sin generar ningún diálogo sobre ello. Esto es útil para herramientas como pbuilder. Opción de configuración: APT::Get::AllowUnauthenticated.

-h, --help
    Muestra un mensaje corto sobre el uso.

-v, --version
    Muestra la versión del programa.

-c, --config-file
    Fichero de configuración: Especifica el fichero de configuración a usar. El programa leerá el fichero de configuración predeterminado y, después, este fichero de configuración. Si necesita que ciertas opciones de configuración se definan antes que el análisis de los de los ficheros de configuración predeterminados, defina un fichero con la variable de entorno APT_CONFIG. Consulte apt.conf(5) para información sobre la sintaxis.

-o, --option
    Define una opción de configuración: Esto definirá una opción arbitraria de configuración. La sintaxis es -o Algo::Cosa=cosa. -o y --option se pueden usar varias veces para definir diferentes opciones.

FICHEROS

/etc/apt/sources.list
    Ubicaciones de dónde conseguir los paquetes. Opción de configuración: Dir::Etc::SourceList.

/etc/apt/sources.list.d/
    Fragmentos de fichero para las ubicaciones de dónde descargar los paquetes. Opción de configuración: Dir::Etc::SourceParts.

/etc/apt/apt.conf
    Fichero de configuración de APT. Opción de configuración: Dir::Etc::Main.

/etc/apt/apt.conf.d/
    Fragmentos del fichero de configuración de APT. Opción de configuración: Dir::Etc::Parts.

/etc/apt/preferences
    Ficheros de preferencias de versión. Aquí puede especificar el anclaje ("pinning"), una preferencia para conseguir ciertos paquetes a partir de una fuente diferente o de una versión diferente de una distribución. Opción de configuración: Dir::Etc::Preferences.

/etc/apt/preferences.d/
    Fragmentos de fichero para las preferencias de la versión. Opción de configuración: Dir::Etc::PreferencesParts.

/var/cache/apt/archives/
    Área de almacenamiento para los ficheros de paquetes descargados. Opción de configuración: Dir::Cache::Archives.

/var/cache/apt/archives/partial/
    Área de almacenamiento para los ficheros de paquete en tránsito. Opción de configuración: Dir::Cache::Archives (parcialmente implícito).

/var/lib/apt/lists/
    Área de almacenamiento para la información del estado de cada fuente de paquetes especificado en sources.list(5) Opción de configuración: Dir::State::Lists.

/var/lib/apt/lists/partial/
    Área de almacenamiento para la información del estado en tránsito. Opción de configuración: Dir::State::Lists (parcialmente implícito).

VéASE TAMBIéN

apt-cache(8), apt-cdrom(8), dpkg(1), dselect(1), sources.list(5), apt.conf(5), apt-config(8), apt-secure(8), la guía de usuario de APT en /usr/share/doc/apt-doc/, apt_preferences(5), el Cómo de APT.

DIAGNóSTICOS

apt-get devuelve cero si no hay ningún error, y el valor 100 en caso de error.

AUTORES ORIGINALES

Jason Gunthorpe

AUTORES ACTUALES

Equipo de APT

Página de QA[1]

BUGS

Página de errores de APT[2]. Si quiere informar de un error en APT, consulte /usr/share/doc/debian/bug-reporting.txt o use la orden reportbug(1).

TRADUCCIÓN

La traducción al español la realizaron Ismael Fanlo, Carlos Mestre, Rudy Godoy, Gustavo Saldumbide, Javier Fernández-Sanguino y Rubén Porras Campo entre los años 2003 y 2004. La traducción fue actualizada por Francisco Javier Cuadrado y Omar Campagne Polaino entre los años 2009 y 2010.

Tenga en cuenta que este documento puede contener secciones sin traducir. Esto es intencionado para evitar perder contenido cuando la traducción no está actualizada con respecto al documento original.

AUTHORS

Jason Gunthorpe

Equipo de APT

NOTES

1.  Página de QA
    http://packages.qa.debian.org/a/apt.html

2.  Página de errores de APT
    http://bugs.debian.org/src:apt